!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!                The Lorenz Equations
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
      INCLUDE "equations.f90"
!----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)
      DOUBLE PRECISION rho, beta, sigma, x, y, z

        CALL GETRHS(NDIM,U,PAR,F)

      END SUBROUTINE FUNC
!---------------------------------------------------------------------- 

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T
      DOUBLE PRECISION rho, beta, sigma, x, y, z

        rho   = 0.d0
        beta  = 8.d0/3.d0 
        sigma =10.d0 

        x = 0.d0
        y = 0.d0
        z = 0.d0

        PAR(1) = rho
        PAR(2) = beta
        PAR(3) = sigma

        U(1) = x
        U(2) = y
        U(3) = z

      END SUBROUTINE STPNT
!---------------------------------------------------------------------- 

      SUBROUTINE PVLS(NDIM,U,PAR)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)

      DOUBLE PRECISION, EXTERNAL :: GETP,GETU2
      INTEGER NDX,NCOL,NTST

!       PAR(12) is the wanted rho value, as set in the Python script:
        PAR(16)= PAR(1) - PAR(12)

!       Set PAR(21) equal to the real stable Floquet multiplier:

        IF(GETP('EIG',3,U) .LT. 1)THEN
          PAR(21) = GETP('EIG',3,U)
        ELSEIF(GETP('EIG',5,U) .LT. 1)THEN
          PAR(21) = GETP('EIG',5,U)
        ELSE
          Print*,"Error in Floquet multiplier in PVLS in lor.f90"
          STOP
        ENDIF

      END SUBROUTINE PVLS
!---------------------------------------------------------------------- 
      SUBROUTINE BCND 
      END SUBROUTINE BCND

      SUBROUTINE ICND 
      END SUBROUTINE ICND

      SUBROUTINE FOPT 
      END SUBROUTINE FOPT
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
