C---------------------------------------------------------------------- 
C----------------------------------------------------------------------
      INCLUDE "equations.f"	
C---------------------------------------------------------------------- 
      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
C     ---------- ---- 
C 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION U(NDIM),PAR(*),F(NDIM)
C
C Get the RHS of the dynamical systems
      CALL GETRHS(NDIM,U,PAR,F)
C Scale
      T = PAR(11)
      DO i=1,NDIM
        F(i) = T*F(i)
      ENDDO
C 
      RETURN 
      END 
C---------------------------------------------------------------------- 
C---------------------------------------------------------------------- 
      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
C     ---------- ---- 
C 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION PAR(*),ICP(*),U0(NDIM),U1(NDIM),FB(NBC),DBC(NBC,*) 
      DIMENSION V1(3),V2(3)
C
      rho  = PAR(1)
      beta = PAR(2)
      sigma= PAR(3)
C
C Eigenvector 1
      V1(1) = 0.
      V1(2) = 0.
      V1(3) = 1.

C Eigenvector 2
      d = (sigma+1)**2 - 4*sigma*(1-rho)
      ev2 = ( -(sigma+1) - DSQRT(d) )/2
      V2(1) = (1+ev2)/rho
      V2(2) = 1.
      V2(3) = 0.

C Scale eigenvector 2
      sc = 1.0/DSQRT( V2(1)**2 + V2(2)**2 + V2(3)**2 )
      V2(1) = sc*V2(1)
      V2(2) = sc*V2(2)
      V2(3) = sc*V2(3)
C
C At time=0
      pi    = 4*DATAN(1.d0)
      eps   = PAR(9)
      theta = PAR(10)
      angle = 2*pi*theta
      sn    = DSIN(angle)
      cs    = DCOS(angle)
C
      FB(1)= U0(1) - eps * ( sn*V1(1) + cs*V2(1) )
      FB(2)= U0(2) - eps * ( sn*V1(2) + cs*V2(2) )
      FB(3)= U0(3) - eps * ( sn*V1(3) + cs*V2(3) )
C
C The coordinates of the endpoint of the orbit in the stable manifold
      x1 = U1(1)
      y1 = U1(2)
      z1 = U1(3)
C
      FB(4) = x1 - PAR(21)
      FB(5) = y1 - PAR(22)
      FB(6) = z1 - PAR(23)
C
C Constraint on orbits (the 2nd factor is negative ... )
      FB(7) =  ( PAR(11)-PAR(31) ) * ( PAR(13)-PAR(33) )  + PAR(24)
C
C The distance of the orbit end point to the center of the sphere
      FB(8) =  DSQRT(x1**2 + y1**2 + (z1-rho+1.d0)**2)  - PAR(13)
C
C Orthogonality of end points on the sphere with the vector field
          vx = sigma*(y1-x1)
          vy = rho*x1 - y1 - x1*z1
          vz = x1*y1 -  beta*z1
          xn=x1
          yn=y1
          zn= z1 - rho + 1
          rn= SQRT(xn**2 + yn**2 + zn**2)
          xn=xn/rn
          yn=yn/rn
          zn=zn/rn
          rv= SQRT(vx**2 + vy**2 + vz**2)
          vx = vx/rv
          vy = vy/rv
          vz = vz/rv
          FB(9) = xn*vx + yn*vy + zn*vz - PAR(25)
C
      RETURN 
      END 
C---------------------------------------------------------------------- 
C---------------------------------------------------------------------- 
      SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
C     ---------- ----
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NDIM),UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
      DIMENSION FI(NINT),DINT(NINT,*),ICP(*),PAR(*)
      PARAMETER(NDM=3)
      DIMENSION FF(NDM)
C
C Length of the orbit in the stable manifold
C
      CALL GETRHS(NDIM,U,PAR,FF)
C
      T=PAR(11)
      Q=0.d0
      DO i=1,NDM
        Q = Q + (T*FF(i))**2
      ENDDO
      FI(1) = DSQRT(Q) - PAR(12)
C
      RETURN 
      END 
C---------------------------------------------------------------------- 
C---------------------------------------------------------------------- 
      SUBROUTINE PVLS(NDIM,U,PAR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      RETURN
      END
C----------------------------------------------------------------------
C---------------------------------------------------------------------- 
      SUBROUTINE STPNT(NDIM,U,PAR,time) 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      RETURN 
      END 
C---------------------------------------------------------------------- 
C---------------------------------------------------------------------- 
      SUBROUTINE FOPT 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      RETURN 
      END 
C---------------------------------------------------------------------- 
C---------------------------------------------------------------------- 
