C---------------------------------------------------------------------- 
C---------------------------------------------------------------------- 
C       The Lorenz Equations
C---------------------------------------------------------------------- 
C---------------------------------------------------------------------- 
C 
      SUBROUTINE GETRHS(NDM,V,PAR,FF) 
C     ---------- ------
C 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION V(NDM),PAR(*),FF(NDM)
C
C Define the RHS of the dynamical system
C
       rho =  PAR(1)
       beta = PAR(2)
       sigma= PAR(3)
C
       x = V(1)
       y = V(2)
       z = V(3)
C
       FF(1)= sigma*(y-x)
       FF(2)= rho*x - y - x*z
       FF(3)= x*y -  beta*z
C
      RETURN
      END
C---------------------------------------------------------------------- 
      SUBROUTINE GETJAC(NDM,V,PAR,DF) 
C     ---------- ------
C 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION V(NDM),PAR(*),DF(NDM,*)
C
C Define the Jacobian
C
       rho =  PAR(1)
       beta = PAR(2)
       sigma= PAR(3)
C
       x = V(1)
       y = V(2)
       z = V(3)
C
       DF(1,1) =-sigma
       DF(1,2) = sigma
       DF(1,3) = 0.

       DF(2,1) = rho - z
       DF(2,2) =-1.d0
       DF(2,3) =-x

       DF(3,1) = y
       DF(3,2) = x
       DF(3,3) =-beta
C
      RETURN
      END
C---------------------------------------------------------------------- 
C---------------------------------------------------------------------- 
