!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!   lor :     The Lorenz Equations
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

  SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!     ---------- ---- 

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
  DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
  DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
  DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

  DOUBLE PRECISION rho, beta, sigma, x, y, z
    
   x = U(1)
   y = U(2)
   z = U(3)

   rho   = PAR(1)
   beta  = PAR(2)
   sigma = PAR(3)

   F(1) = sigma*(y-x)
   F(2) = rho*x - y - x*z
   F(3) = x*y -  beta*z

  END SUBROUTINE FUNC
!---------------------------------------------------------------------- 

  SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- ----- 

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NDIM
  DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
  DOUBLE PRECISION, INTENT(IN) :: T

  DOUBLE PRECISION rho, beta, sigma, period, x, y, z

! Parameter values for the starting orbit in lor.dat :
   rho  = 250.
   beta = 8.d0/3.d0 
   sigma= 10. 
   period = 0.460094

   PAR(1) = rho
   PAR(2) = beta
   PAR(3) = sigma
   PAR(11)= period

  END SUBROUTINE STPNT
!---------------------------------------------------------------------- 

  SUBROUTINE BCND 
  END SUBROUTINE BCND

  SUBROUTINE ICND 
  END SUBROUTINE ICND

  SUBROUTINE FOPT 
  END SUBROUTINE FOPT

  SUBROUTINE PVLS
  END SUBROUTINE PVLS
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
